﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HeuristicLab.Problems.Instances.DataAnalysis.Regression.Matlab.Api.Types {
    public interface IMLTimeseries : IMLVariable {
        /// <summary>
        /// Data headers of the timeseries.
        /// </summary>
        string[] DataHeader { get; }

        /// <summary>
        /// Returns the values of the timeseries for a given time.
        /// </summary>
        /// <param name="time"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        double[] GetValuesByTime(double time);

        /// <summary>
        /// Returns the values for a given time index.
        /// This index is not a time.
        /// </summary>
        /// <param name="idx"></param>
        /// <returns></returns>
        double[] this[int idx] { get; }

        /// <summary>
        /// Returns an array which contains all time values.
        /// </summary>
        double[] Times { get; }

        /// <summary>
        /// Returns the time at a specific index.
        /// </summary>
        /// <param name="idx"></param>
        /// <returns></returns>
        double GetTimeAt(int idx);

        /// <summary>
        /// Returns the number of value entries.
        /// </summary>
        int Count { get; }
    }
}
